using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace ThreadExample
{
	public class MainForm : System.Windows.Forms.Form
	{
		private Thread firstThread;
		private Thread secondThread;
		private int interval = 10000000;

		private delegate void UpdateTextBoxDelegate(string strText);

		#region Windows Form Designer generated code

		private System.Windows.Forms.Button btnStart;
		private System.Windows.Forms.TextBox txtMain;
		private System.Windows.Forms.Button btnStop1;
		private System.Windows.Forms.Button btnPause1;
		private System.Windows.Forms.Button btnResume1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtInterval;
		private System.Windows.Forms.GroupBox grpPriority1;
		private System.Windows.Forms.RadioButton radLow1;
		private System.Windows.Forms.RadioButton radNormal1;
		private System.Windows.Forms.RadioButton radHigh1;
		private System.Windows.Forms.GroupBox grpPriority2;
		private System.Windows.Forms.RadioButton radHigh2;
		private System.Windows.Forms.RadioButton radNormal2;
		private System.Windows.Forms.RadioButton radLow2;
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}
		
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void InitializeComponent()
		{
			this.btnStart = new System.Windows.Forms.Button();
			this.txtMain = new System.Windows.Forms.TextBox();
			this.btnStop1 = new System.Windows.Forms.Button();
			this.btnPause1 = new System.Windows.Forms.Button();
			this.btnResume1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.txtInterval = new System.Windows.Forms.TextBox();
			this.grpPriority1 = new System.Windows.Forms.GroupBox();
			this.radLow1 = new System.Windows.Forms.RadioButton();
			this.radNormal1 = new System.Windows.Forms.RadioButton();
			this.radHigh1 = new System.Windows.Forms.RadioButton();
			this.grpPriority2 = new System.Windows.Forms.GroupBox();
			this.radHigh2 = new System.Windows.Forms.RadioButton();
			this.radNormal2 = new System.Windows.Forms.RadioButton();
			this.radLow2 = new System.Windows.Forms.RadioButton();
			this.grpPriority1.SuspendLayout();
			this.grpPriority2.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnStart
			// 
			this.btnStart.Location = new System.Drawing.Point(192, 60);
			this.btnStart.Name = "btnStart";
			this.btnStart.Size = new System.Drawing.Size(104, 24);
			this.btnStart.TabIndex = 0;
			this.btnStart.Text = "Start Threads";
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			// 
			// txtMain
			// 
			this.txtMain.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.txtMain.Location = new System.Drawing.Point(16, 16);
			this.txtMain.Multiline = true;
			this.txtMain.Name = "txtMain";
			this.txtMain.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtMain.Size = new System.Drawing.Size(160, 344);
			this.txtMain.TabIndex = 1;
			this.txtMain.Text = "";
			// 
			// btnStop1
			// 
			this.btnStop1.Location = new System.Drawing.Point(192, 154);
			this.btnStop1.Name = "btnStop1";
			this.btnStop1.Size = new System.Drawing.Size(104, 24);
			this.btnStop1.TabIndex = 2;
			this.btnStop1.Text = "Stop Thread 1";
			this.btnStop1.Click += new System.EventHandler(this.btnStop1_Click);
			// 
			// btnPause1
			// 
			this.btnPause1.Location = new System.Drawing.Point(192, 91);
			this.btnPause1.Name = "btnPause1";
			this.btnPause1.Size = new System.Drawing.Size(104, 24);
			this.btnPause1.TabIndex = 3;
			this.btnPause1.Text = "Pause Thread 1";
			this.btnPause1.Click += new System.EventHandler(this.btnPause1_Click);
			// 
			// btnResume1
			// 
			this.btnResume1.Location = new System.Drawing.Point(192, 122);
			this.btnResume1.Name = "btnResume1";
			this.btnResume1.Size = new System.Drawing.Size(104, 24);
			this.btnResume1.TabIndex = 4;
			this.btnResume1.Text = "Resume Thread 1";
			this.btnResume1.Click += new System.EventHandler(this.btnResume1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(193, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.TabIndex = 5;
			this.label1.Text = "Interval to use:";
			// 
			// txtInterval
			// 
			this.txtInterval.Location = new System.Drawing.Point(194, 32);
			this.txtInterval.Name = "txtInterval";
			this.txtInterval.Size = new System.Drawing.Size(102, 20);
			this.txtInterval.TabIndex = 6;
			this.txtInterval.Text = "10000000";
			// 
			// grpPriority1
			// 
			this.grpPriority1.Controls.Add(this.radHigh1);
			this.grpPriority1.Controls.Add(this.radNormal1);
			this.grpPriority1.Controls.Add(this.radLow1);
			this.grpPriority1.Location = new System.Drawing.Point(192, 186);
			this.grpPriority1.Name = "grpPriority1";
			this.grpPriority1.Size = new System.Drawing.Size(104, 86);
			this.grpPriority1.TabIndex = 7;
			this.grpPriority1.TabStop = false;
			this.grpPriority1.Text = "Thread 1 Priority";
			// 
			// radLow1
			// 
			this.radLow1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.radLow1.Location = new System.Drawing.Point(8, 24);
			this.radLow1.Name = "radLow1";
			this.radLow1.Size = new System.Drawing.Size(56, 16);
			this.radLow1.TabIndex = 0;
			this.radLow1.Text = "Low";
			// 
			// radNormal1
			// 
			this.radNormal1.Checked = true;
			this.radNormal1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.radNormal1.Location = new System.Drawing.Point(8, 43);
			this.radNormal1.Name = "radNormal1";
			this.radNormal1.Size = new System.Drawing.Size(64, 16);
			this.radNormal1.TabIndex = 1;
			this.radNormal1.Text = "Normal";
			// 
			// radHigh1
			// 
			this.radHigh1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.radHigh1.Location = new System.Drawing.Point(8, 64);
			this.radHigh1.Name = "radHigh1";
			this.radHigh1.Size = new System.Drawing.Size(64, 16);
			this.radHigh1.TabIndex = 2;
			this.radHigh1.Text = "High";
			// 
			// grpPriority2
			// 
			this.grpPriority2.Controls.Add(this.radHigh2);
			this.grpPriority2.Controls.Add(this.radNormal2);
			this.grpPriority2.Controls.Add(this.radLow2);
			this.grpPriority2.Location = new System.Drawing.Point(192, 280);
			this.grpPriority2.Name = "grpPriority2";
			this.grpPriority2.Size = new System.Drawing.Size(104, 88);
			this.grpPriority2.TabIndex = 8;
			this.grpPriority2.TabStop = false;
			this.grpPriority2.Text = "Thread 2 Priority";
			// 
			// radHigh2
			// 
			this.radHigh2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.radHigh2.Location = new System.Drawing.Point(8, 63);
			this.radHigh2.Name = "radHigh2";
			this.radHigh2.Size = new System.Drawing.Size(64, 16);
			this.radHigh2.TabIndex = 2;
			this.radHigh2.Text = "High";
			// 
			// radNormal2
			// 
			this.radNormal2.Checked = true;
			this.radNormal2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.radNormal2.Location = new System.Drawing.Point(8, 42);
			this.radNormal2.Name = "radNormal2";
			this.radNormal2.Size = new System.Drawing.Size(64, 16);
			this.radNormal2.TabIndex = 1;
			this.radNormal2.TabStop = true;
			this.radNormal2.Text = "Normal";
			// 
			// radLow2
			// 
			this.radLow2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.radLow2.Location = new System.Drawing.Point(8, 21);
			this.radLow2.Name = "radLow2";
			this.radLow2.Size = new System.Drawing.Size(56, 16);
			this.radLow2.TabIndex = 0;
			this.radLow2.Text = "Low";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(304, 373);
			this.Controls.Add(this.grpPriority2);
			this.Controls.Add(this.grpPriority1);
			this.Controls.Add(this.txtInterval);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnResume1);
			this.Controls.Add(this.btnPause1);
			this.Controls.Add(this.btnStop1);
			this.Controls.Add(this.txtMain);
			this.Controls.Add(this.btnStart);
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Threading Example";
			this.grpPriority1.ResumeLayout(false);
			this.grpPriority2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnStart_Click(object sender, System.EventArgs e)
		{
			this.txtMain.Text = "";
			try
			{
				interval = Convert.ToInt32(this.txtInterval.Text);
			}
			catch 
			{
				interval = 10000000;
				this.txtInterval.Text = interval.ToString();
			}

			ThreadStart workerStart1 = new ThreadStart(ShowValues);
			firstThread = new Thread(workerStart1);
			firstThread.Name = "Thread 1";

			if (this.radLow1.Checked)
			{
				firstThread.Priority = ThreadPriority.BelowNormal;
			}
			else if (this.radNormal1.Checked)
			{
				firstThread.Priority = ThreadPriority.Normal;
			}
			else
			{
				firstThread.Priority = ThreadPriority.AboveNormal;
			}

			ThreadStart workerStart2 = new ThreadStart(ShowValues);
			secondThread = new Thread(workerStart2);
			secondThread.Name = "Thread 2";

			if (this.radLow2.Checked)
			{
				secondThread.Priority = ThreadPriority.BelowNormal;
			}
			else if (this.radNormal2.Checked)
			{
				secondThread.Priority = ThreadPriority.Normal;
			}
			else
			{
				secondThread.Priority = ThreadPriority.AboveNormal;
			}

			firstThread.Start();
			secondThread.Start();
		}

		private void ShowValues()
		{
			Thread thisThread = Thread.CurrentThread;

			UpdateTextBox("\r\nStarting: " + thisThread.Name);

			for (int i=1; i <= 10 * interval; i++)
			{
				if (i % interval == 0)
				{
					UpdateTextBox("\r\n" + thisThread.Name + " " + i.ToString());
				}
			}
			UpdateTextBox("\r\nComplete: " + thisThread.Name);
		}

		private void btnStop1_Click(object sender, System.EventArgs e)
		{
			if (firstThread.IsAlive)
			{
				firstThread.Abort();		
				UpdateTextBox("\r\nAbort: " + firstThread.Name);
			}
		}

		private void btnPause1_Click(object sender, System.EventArgs e)
		{
			if (firstThread.ThreadState == ThreadState.Running)
			{
				firstThread.Suspend();		
				UpdateTextBox("\r\nSuspend: " + firstThread.Name);
			}
		}

		private void btnResume1_Click(object sender, System.EventArgs e)
		{
			if (firstThread.ThreadState == ThreadState.Suspended)
			{
				firstThread.Resume();				
				UpdateTextBox("\r\nResume: " + firstThread.Name);
			}
		}
	
		private void UpdateTextBox(string strText)
		{
			if(this.txtMain.InvokeRequired)
			{
				UpdateTextBoxDelegate updtDel = new UpdateTextBoxDelegate(UpdateTextBox);
				this.Invoke(updtDel,new object[] {strText});
			}
			else
			{
				this.txtMain.Text += strText;
			}
		}

	} //class

} //namespace
